﻿window.zzExitFlag=false;

//## com #################################################################################

function zzHtmlSpecialChars(str){
	if(!str)return '';
	
	str = str.replace(/&/g, '&amp;');  
	str = str.replace(/</g, '&lt;');  
	str = str.replace(/>/g, '&gt;');  
	str = str.replace(/"/g, '&quot;');  
	str = str.replace(/'/g, '&#039;');  
	return str;  
}

var zzWhenTheTableTrOnClick_lastRId = '';
function zzWhenTheTableTrOnClick(id){
    if(zzWhenTheTableTrOnClick_lastRId){
        $('#'+zzWhenTheTableTrOnClick_lastRId).removeClass('zzSel');
    }

    var rid = 'r' + id;
    zzWhenTheTableTrOnClick_lastRId = rid;

    $('#'+rid).addClass('zzSel');    
}

function zzBuildPagerHtml(rst){
    var x = rst.data.x;
    var ct = rst.data.pagect;

    var h='<div>';

    if(x>0){
        h+='<a href="javascript:void(0)" onclick="zzgo(0)">首页</a>';
        h+='<a href="javascript:void(0)" onclick="zzgo('+(x-1)+')">上一页</a>';
    }else{
        h+='<a style="color:#C0C0C0;">首页</a>';
        h+='<a style="color:#C0C0C0;">上一页</a>';
    }

    for(var i=0; i<ct; i++){
        if(i>=x-7 && i<=x+7){
            if(i!=x){
                h+='<a href="javascript:void(0)" onclick="zzgo('+i+')">'+(i+1)+'</a>';
            }else{
                h+='<a style="color:#C0C0C0;">'+(i+1)+'</a>';
            }
        }
    }

    if(x<ct-1){
        h+='<a href="javascript:void(0)" onclick="zzgo('+(x+1)+')">下一页</a>';
        h+='<a href="javascript:void(0)" onclick="zzgo('+(ct-1)+')">末页('+ct+')</a>';
    }else{
        h+='<a style="color:#C0C0C0;">下一页</a>';
        h+='<a style="color:#C0C0C0;">末页('+ct+')</a>';
    }

    h+='</div>';

    return h;
}

//## log #################################################################################

function zzLogout(){
    $.ajax({
        url:'/logout',
        type : "POST",
        data:{},
        success:function(result){
            if(zzExitFlag)return;
            
            var ret = !result ? '' : result.trim();
            if(ret=='ok'){
                window.zzExitFlag=true;
                location.href='auth.html';
            }else{
                alert(result);
            }
        },
        error:function(){
            if(zzExitFlag)return;

            alert('服务器错误');
            return;
        }
    });
}

//## uprom #################################################################################
var zzUpRom_ticker=0;
var zzUpRom_disconnFlag=0;
function zzUpRom_doing(){
    if(zzUpRom_ticker<132){
        zzUpRom_ticker+=1;
        zzShowProgress(zzUpRom_ticker,150);
    }
    setTimeout(zzAjaxGetBasic_forUpRom,100);
}

function zzAjaxGetBasic_forUpRom(){
    var zzUpRom_start = new Date().valueOf();
    $.ajax({
        url:'/ajax_getbasic',
        type : "POST",
        dataType: 'json',
        success:function(rst){
            if(zzExitFlag)return;
            
            var zzUpRom_end = new Date().valueOf();
            var dif = zzUpRom_end-zzUpRom_start;
            var more = dif/5000;
            zzUpRom_disconnFlag+=more;
            
            if(zzUpRom_disconnFlag<=2){
                zzUpRom_doing();
                return;
            }
            
            if(!rst||!rst.code||!rst.data){
                zzUpRom_doing();
                return;
            }
            
            zzShowProgress();
            
            if(!rst.data.uprst||rst.data.uprst=='ok'||rst.data.uprst.indexOf('ok:')==0){
                if(rst.data.ver){
                    alert('升级成功\r\n\r\n已升级到版本: '+rst.data.ver+'\r\n\r\n请重启打印机');
                }else{
                    alert('升级出错\r\n\r\n请重启设备后重试,或联系管理员');
                }
            }else{
                alert('升级出错\r\n\r\n'+rst.data.uprst);
            }
            
            zzExitFlag=true;
            location.href='/';     
        },
        error:function(){
            if(zzExitFlag)return;
            
            zzUpRom_disconnFlag++;
            var zzUpRom_end = new Date().valueOf();
            var dif = zzUpRom_end-zzUpRom_start;
            var more = dif/2500;
            zzUpRom_disconnFlag+=more;
            
            zzUpRom_doing();
        }
    });
}

function zzOnUploadProgress(evt) {
    if (evt.lengthComputable) {
        zzShowProgress(evt.loaded,evt.total);
    }else{
        zzShowProgress(1,1);
    }
}

function zzDoUploadFile() {
    var file_data = new FormData(document.getElementById('form1'));
    $.ajax({
        url: '/uprom',
        type: 'POST',
        data: file_data,
        processData: false,
        contentType: false,
        cache: false,
        xhr: function() {
            myXhr = $.ajaxSettings.xhr();
            if(myXhr.upload){
                myXhr.upload.addEventListener('progress',zzOnUploadProgress, false); // for handling the progress of the upload
            }
            return myXhr;
        },
    }).done(function(data) {
        var ret = !data ? '' : data.trim();
    
        if(ret=='ok'||ret.indexOf('ok:')==0){
            zzShowProgress();

            var h='';
            h+='<table style="width:100%;">';
            h+='    <tr>';
            h+='        <td style="width:100%;text-align:center;" colspan=3>上传固件完成<br>正在升级设备, 请勿操作设备..</td>';
            h+='    </tr>';
            h+='    <tr>';
            h+='        <td style="width:50%;"></td>';
            h+='        <td style="width:150px;text-align:right;">';
            h+='            <div id="divProgress" style="width:150px;height:1px;background:#f0f0f0;">';
            h+='                <div id="divProgressDealed" style="width:50px;height:100%;background:#258585;"></div>';
            h+='            </div>';
            h+='        </td>';
            h+='        <td style="width:50%;"></td>';
            h+='    </tr>';
            h+='</table>';
            $('#main').html(h);

            zzUpRom_ticker=0;
            zzUpRom_disconnFlag=0;
            zzUpRom_doing();

        }else if(ret=='登录过期'){
            zzShowProgress();
            alert('上传固件出错\r\n\r\n'+ret);
            zzExitFlag=true;
            location.href='auth.html';
        }else{
            zzShowProgress();
            alert('上传固件出错\r\n\r\n'+ret);
            zzExitFlag=true;
            location.href=location.href;                
        }
    });
    return false;
}

function zzShowProgress(d,a){
    if(!d||!a||d<=0||a<=0){
        $('#divProgress').css('background-color','transparent');
        $('#divProgressDealed').css('background-color','transparent');
        return;
    }
    
    $('#divProgress').css('background-color','#f0f0f0');
    var p;
    if(d>=a){
        p=150;
    }else{
        p=Math.floor(d*150/a);
    }
    if(p<=0){
        $('#divProgressDealed').css('background-color','transparent');
        return;
    }
    
    $('#divProgressDealed').css('background-color','#258585');
    $('#divProgressDealed').width(p);
}    

//## lans #################################################################################
function zzRefreshIpSuit_byDhcpValue(onoff){
    if(onoff){
        $("#zzip").attr("disabled","disabled");
        $("#zzmask").attr("disabled","disabled");
        $("#zzgate").attr("disabled","disabled");
    }else{
        $("#zzip").removeAttr("disabled");
        $("#zzmask").removeAttr("disabled");
        $("#zzgate").removeAttr("disabled");
    }
}
function zzRefreshIpSuit_byDhcpElement(){
    if( $("#zzdhcp:checked").val() ){
        zzRefreshIpSuit_byDhcpValue(true);
    }else{
        zzRefreshIpSuit_byDhcpValue(false);
    }
}

function zzGetLansInfos(){
    $.ajax({
        url:'/ajax_getlans',
        type : "POST",
        dataType: 'json',
        success:function(rst){
            if(zzExitFlag)return;

            if(!rst||!rst.code){
                alert('服务器错误');
                return;
            }
            if(!rst.data||!rst.data.items){
                alert('服务器错误');
                return;
            }
            if(rst.data.ct<1){
                alert('打印机不支持有线网卡');
                return;
            }
            
            var r = rst.data.items[0];
            if(r.dhcp){
                $('#zzdhcp').attr('checked',true);
            }else{
                $('#zzdhcp').attr('checked',false);
            }
            
            $('#zzip').val(r.ip);
            $('#zzmask').val(r.mask);
            $('#zzgate').val(r.gate);
            
            zzRefreshIpSuit_byDhcpValue(r.dhcp);
        },
	    error:function(){
            if(zzExitFlag)return;

        	alert('服务器错误');
		    return;							
	    }
    });        
}

function zzSetLanInfo(){
    var data={};
    data.dhcp = ($("#zzdhcp:checked").val()?1:0);
    data.ip = $('#zzip').val();
    data.mask = $('#zzmask').val();
    data.gate = $('#zzgate').val();
    if(!data.dhcp&&!data.ip){
    	alert('请输入IP地址');
		return;
    }
    if(!data.dhcp&&!data.mask){
    	alert('请输入掩码');
		return;
    }

    $.ajax({
		url:'/ajax_setlans',
		type : "POST",
		data:data,
		success:function(result){
            if(zzExitFlag)return;
        
            var ret = !result ? '' : result.trim();
        
            if(ret=='ok'){
                alert('设置成功\r\n\r\n打印机正在重启相关服务,稍后刷新页面即可');
                zzExitFlag=true;
                location.href=location.href;
            }else{
                alert(ret);
            }
		},
		error:function(){
            if(zzExitFlag)return;
            
        	alert('服务器错误');
			return;							
		}	
	});
}

//## email #################################################################################
function zzGetSmtpSettings(){
    $.ajax({
        url:'/ajax_getsmtps',
        type : "POST",
        dataType: 'json',
        success:function(rst){
            if(zzExitFlag)return;

            if(!rst||!rst.code){
                alert('服务器错误');
                return;
            }
            if(!rst.data){
                alert('服务器错误');
                return;
            }
            
            var r = rst.data;
            $('#zzhost').val(r.smtp_host);
            $('#zzusername').val(r.smtp_username);
            if(r.smtp_pass){
                $('#zzpass').val("********");
            }else{
                $('#zzpass').val("");
            }
            $('#zzfrom').val(r.smtp_from);
            $('#zzto').val(r.smtp_to);

        },
	    error:function(){
            if(zzExitFlag)return;

        	alert('服务器错误');
		    return;							
	    }
    });        
}
function zzSetSmtpSettings(){
    var data={};
    data.smtp_host = $('#zzhost').val();
    data.smtp_username = $('#zzusername').val();
    data.smtp_pass = $('#zzpass').val();
    data.smtp_from = $('#zzfrom').val();
    data.smtp_to = $('#zzto').val();
    if(!data.smtp_host&&!data.smtp_username&&!data.smtp_pass&&!data.smtp_from&&!data.smtp_to){
        //zzdonothing: ok
    }else if(!data.smtp_host){
    	alert('请输入邮件服务器');
		return;
    }else if(!data.smtp_username){
    	alert('请输入用户名');
		return;
    }else if(!data.smtp_pass){
    	alert('请输入授权码');
		return;
    }else if(!data.smtp_from){
    	alert('请输入发件人');
		return;
    }else if(!data.smtp_to){
    	alert('请输入收件人');
		return;
    }

    $.ajax({
		url:'/ajax_setsmtps',
		type : "POST",
		data:data,
		success:function(result){
            if(zzExitFlag)return;
        
            var ret = !result ? '' : result.trim();
        
            if(ret=='ok'){
                alert('设置成功');
                zzExitFlag=true;
                location.href=location.href;
            }else{
                alert(ret);
            }
		},
		error:function(){
            if(zzExitFlag)return;
            
        	alert('服务器错误');
			return;							
		}	
	});
}
function zzTestSmtpSettings(){
    var data={};
    data.smtp_host = $('#zzhost').val();
    data.smtp_username = $('#zzusername').val();
    data.smtp_pass = $('#zzpass').val();
    data.smtp_from = $('#zzfrom').val();
    data.smtp_to = $('#zzto').val();
    if(!data.smtp_host&&!data.smtp_username&&!data.smtp_pass&&!data.smtp_from&&!data.smtp_to){
        //zzdonothing: ok
    }else if(!data.smtp_host){
    	alert('请输入邮件服务器');
		return;
    }else if(!data.smtp_username){
    	alert('请输入用户名');
		return;
    }else if(!data.smtp_pass){
    	alert('请输入授权码');
		return;
    }else if(!data.smtp_from){
    	alert('请输入发件人');
		return;
    }else if(!data.smtp_to){
    	alert('请输入收件人');
		return;
    }

    $.ajax({
		url:'/ajax_testsmtps',
		type : "POST",
		data:data,
		success:function(result){
            if(zzExitFlag)return;
        
            var ret = !result ? '' : result.trim();
        
            if(ret=='ok'){
                alert('测试成功');
                //zzExitFlag=true;
                //location.href=location.href;
            }else{
                alert(ret);
            }
		},
		error:function(){
            if(zzExitFlag)return;
            
        	alert('服务器错误');
			return;							
		}	
	});
}




//## qry #################################################################################
window.zzPER = 10;
window.zzPageId = -1;
    
function zzQryGoPageId_log4pfault(x){
    zzPageId=x;

    $.ajax({
        url:'/ajax_log4pfault',
        type : "POST",
        dataType: 'json',
        data:{x:x,f:zzPER},
        success:function(rst){
            if(zzExitFlag)return;
            
            if(!rst||!rst.code){
                alert('服务器错误');
                return;
            }
            if(rst.code==1003){
                zzExitFlag=true;
                location.href='auth.html';
                return;
            }
            if(rst.code!=1000){
                alert(rst.msg);
                return;
            }
            if(!rst.data||!rst.data.items){
                alert('服务器错误');
                return;
            }
            
            if(rst.data.x!=zzPageId)return;
            
            var rs = rst.data.items;
            if(!rs.length){
                $('#zzTheTable tbody').html('');
                $('#zzThePager').html('');
                $('#zzNoData').html('<div style="padding:150px 0 150px 0;text-align:center;">暂无记录</div>');
                return;
            }

            var h='';
            for(var i=0;i<rs.length;i++){
                var r=rs[i];
                h += '<tr id="r'+r.id+'" onclick="zzWhenTheTableTrOnClick('+r.id+')">';
                
                var s = r.w;
                h += '<td>'+s+'</td>';
                
                s=r.pecode.replace(/\//g,'<BR/>');
                h += '<td>'+s+'</td>';
                
                h += '<td>'+r.rst+'</td>';
                
                if(r.jobid){
                    h += '<td>'+r.jobtime+'</td>';
                
                    s=r.docname || '未知文档';
                    if(r.docpagect && r.doccopy)s+='<BR/>每份'+(r.docpagect/r.doccopy)+'页';
                    h += '<td>'+s+'</td>';
                    
                    s='';
                    if(r.doccopy)d=(r.doccopy)+'份';
                    if(s)s+='<BR/>';s+=(r.docpagect)+'页';
                    h += '<td>'+s+'</td>';
                    
                    s='';
                    if(r.okcopy)s=(r.okcopy)+'份';
                    if(s)s+='<BR/>';s+=(r.okpagect)+'页';
                    h += '<td>'+s+'</td>';
                    
                    s='';
                    if(r.cip)s=r.cip;
                    if(r.cmac){if(s)s+='<BR/>';s+=r.cmac;}
                    if(r.cpcname){if(s)s+='<BR/>';s+=r.cpcname;}
                    if(r.cuname){if(s)s+='<BR/>';s+=r.cuname;}
                    h += '<td>'+s+'</td>';
                }else{
                    h += '<td></td>';
                    h += '<td></td>';
                    h += '<td></td>';
                    h += '<td></td>';
                    h += '<td></td>';
                }
                
                h += '</tr>';
            }
            $('#zzTheTable tbody').html(h);

            $('#zzThePager').html(zzBuildPagerHtml(rst));

            $('#zzNoData').html('');
        },
	    error:function(){
            if(zzExitFlag)return;
            
        	alert('服务器错误');
		    return;							
	    }
    });
}    

function zzQryGoPageId_log4print(x){
    zzPageId=x;

    $.ajax({
        url:'/ajax_log4print',
        type : "POST",
        dataType: 'json',
        data:{x:x,f:zzPER},
        success:function(rst){
            if(zzExitFlag)return;
            
            if(!rst||!rst.code){
                alert('服务器错误');
                return;
            }
            if(rst.code==1003){
                zzExitFlag=true;
                location.href='auth.html';
                return;
            }
            if(rst.code!=1000){
                alert(rst.msg);
                return;
            }
            if(!rst.data||!rst.data.items){
                alert('服务器错误');
                return;
            }
            
            if(rst.data.x!=zzPageId)return;
            
            var rs = rst.data.items;
            if(!rs.length){
                $('#zzTheTable tbody').html('');
                $('#zzThePager').html('');
                $('#zzNoData').html('<div style="padding:150px 0 150px 0;text-align:center;">暂无记录</div>');
                return;
            }

            var h='';
            for(var i=0;i<rs.length;i++){
                var r=rs[i];
                h += '<tr id="r'+r.id+'" onclick="zzWhenTheTableTrOnClick('+r.id+')">';
                
                var s = r.jobtime||r.w;
                h += '<td>'+s+'</td>';
                
                h += '<td>'+r.rst+'</td>';
                
                s=r.docname || '未知文档';
                if(r.docpagect && r.doccopy)s+='<BR/>每份'+(r.docpagect/r.doccopy)+'页';
                h += '<td>'+s+'</td>';
                
                s='';
                if(r.doccopy)d=(r.doccopy)+'份';
                if(s)s+='<BR/>';s+=(r.docpagect)+'页';
                h += '<td>'+s+'</td>';
                
                s='';
                if(r.okcopy)s=(r.okcopy)+'份';
                if(s)s+='<BR/>';s+=(r.okpagect)+'页';
                h += '<td>'+s+'</td>';
                
                s='';
                if(r.cip)s=r.cip;
                if(r.cmac){if(s)s+='<BR/>';s+=r.cmac;}
                if(r.cpcname){if(s)s+='<BR/>';s+=r.cpcname;}
                if(r.cuname){if(s)s+='<BR/>';s+=r.cuname;}
                h += '<td>'+s+'</td>';
                
                s=r.pecode.replace(/\//g,'<BR/>');
                h += '<td style="text-align:left;color:#808080;">'+s+'</td>';
                
                h += '</tr>';
            }
            $('#zzTheTable tbody').html(h);

            $('#zzThePager').html(zzBuildPagerHtml(rst));

            $('#zzNoData').html('');
        },
	    error:function(){
            if(zzExitFlag)return;
            
        	alert('服务器错误');
		    return;							
	    }
    });
}

function zzQryGoPageId_log4pset(x){
    zzPageId=x;

    $.ajax({
        url:'/ajax_log4pset',
        type : "POST",
        dataType: 'json',
        data:{x:x,f:zzPER},
        success:function(rst){
            if(zzExitFlag)return;
        
            if(!rst||!rst.code){
                alert('服务器错误');
                return;
            }
            if(rst.code==1003){
                zzExitFlag=true;
                location.href='auth.html';
                return;
            }
            if(rst.code!=1000){
                alert(rst.msg);
                return;
            }
            if(!rst.data||!rst.data.items){
                alert('服务器错误');
                return;
            }
            
            if(rst.data.x!=zzPageId)return;
            
            var rs = rst.data.items;
            if(!rs.length){
                $('#zzTheTable tbody').html('');
                $('#zzThePager').html('');
                $('#zzNoData').html('<div style="padding:150px 0 150px 0;text-align:center;">暂无记录</div>');
                return;
            }

            var h='';
            for(var i=0;i<rs.length;i++){
                var r=rs[i];
                h += '<tr id="r'+r.id+'" onclick="zzWhenTheTableTrOnClick('+r.id+')">';
                h += '<td>'+r.w+'</td>';
                h += '<td>'+r.tp+'</td>';
                h += '<td>'+r.rst+'</td>';
                h += '<td>'+r.o+'</td>';
                h += '<td>'+r.n+'</td>';
                h += '<td style="text-align:left;color:#808080;">'+r.em+'</td>';
                h += '</tr>';
            }
            $('#zzTheTable tbody').html(h);

            $('#zzThePager').html(zzBuildPagerHtml(rst));

            $('#zzNoData').html('');
        },
	    error:function(){
            if(zzExitFlag)return;
        
        	alert('服务器错误');
		    return;							
	    }
    });
}

